#include <stdio.h>

int merge(FILE* fp, FILE* master);

int main(int argc, char** argv)
{
	if(argc < 3)
	{
		puts("This program concatenates two or more patches together.\nThe output file will be the last in the list\nUsage: ipscat patch1.ips patch2.ips [patch3.ips ...] masterpatch.ips\nNote: The patches will be applied in reverse order,\nso if you want to apply patch_a AFTER patch_b use command:\nipscat patch_a.ips patch_b.ips masterpatch.ips\nThis program comes with no warranty whatsoever.\nJoni Munukka 2017");
		return 1;
	}
	FILE* master=fopen(argv[--argc], "wb");
	fputs("PATCH", master);
	while(argc > 1)
		{
		FILE* fp=fopen(argv[--argc], "rb");
		if(!fp)
		{
			printf("File \"%s\" could not be opened!\n", argv[argc]);
			continue;
		}
		if(merge(fp, master)) printf("File \"%s\" is not a patch!\n", argv[argc]);
		fclose(fp);
	}
	fputs("EOF", master);
	fclose(master);
	return 0;
}
int merge(FILE* fp, FILE* master)
{
	fseek(fp, 0, SEEK_END);
	unsigned len=ftell(fp);
	rewind(fp);
	if(!(fgetc(fp)=='P' &&
	     fgetc(fp)=='A' &&
	     fgetc(fp)=='T' &&
	     fgetc(fp)=='C' &&
	     fgetc(fp)=='H')) return 1;
	for(unsigned i=4; i<len-4; ++i)
		fputc(fgetc(fp), master);
	return 0;
}
